//==============================================================================
//  ILI9488,  EMI
//==============================================================================

#define F_CPU 16000000UL

#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

//    UTFT
#define BLACK		  0x0000
#define WHITE		  0xFFFF
#define RED			  0xF800
#define GREEN		  0x0780
#define BLUE		  0x001F
#define SILVER		  0xC618
#define GRAY		  0x8410
#define MAROON		  0x8000
#define YELLOW		  0xFFE0
#define OLIVE		  0x8400
#define LIME		  0x07E0
#define AQUA		  0x07FF
#define TEAL		  0x0410
#define NAVY		  0x0010
#define FUCHSIA		  0xF81F
#define PURPLE		  0x8010

char str[30];

void init(void);

void initTFT(void);

void print_str(
		unsigned int x_pos, unsigned int y_pos,
		unsigned int color, unsigned int back_color,
		char *str);

void fillScreen(unsigned int color);
void fillScreenM(unsigned int color);

volatile unsigned int X_SIZE = 0;	//   
volatile unsigned int Y_SIZE = 0;	//     tftinit

unsigned long XY_LEN = 153600UL;	// 320*480 

unsigned int ccc[256];

//==============================================================================
void initT1(void)
{	TCCR1A = 0x00;	TCCR1B = 0x05;
	TCNT1H = 0x00;	TCNT1L = 0x00;
	ICR1H  = 0x00;	ICR1L  = 0x00;
	OCR1AH = 0x00;	OCR1AL = 0x00;
	OCR1BH = 0x00;	OCR1BL = 0x00;
	OCR1CH = 0x00;	OCR1CL = 0x00;
}
//==============================================================================

//==============================================================================
int main(void)
{
//    
	for (unsigned int id = 0; id < 256; id++) ccc[id] = (id<<5) + 255;

	initT1();

	XMCRA = 0x80;

	initTFT();
	
	char str[20]; 
	unsigned int tmp = 0;
	unsigned int col[16] = 
	{	BLACK,	WHITE,	RED,	GREEN,	BLUE,	SILVER,	GRAY,	MAROON,
		YELLOW,	OLIVE,	LIME,	AQUA,	TEAL,	NAVY,	FUCHSIA,PURPLE
	};
	unsigned char takt = 0;

	while(1)
	{
		TCNT1 = 0;	
//		fillScreen(col[takt]);  //   
//
		fillScreenM(col[takt]); //   
		tmp = TCNT1;

		sprintf(str,"TCNT1=%d*64us",tmp);
		print_str(20,50,WHITE,BLUE,str);

		_delay_ms(1000);	
		takt++;
		takt &= 15;

		fillScreen(BLACK);

	}
	return 0;
} // main
//==============================================================================
